
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Spring Boot POM 详解 / iVAN</title>

    <meta name="description" content="Spring Boot POM 详解         正如这幅图所展示的那样,在Spring IO Framework体系中,Spring Boot处在Execution layer,来看看官方对这层的解释:     The Spring IO Execution layer provides domain-specific runtimes (DSRs) for applications built on the IO Foundation modules. A DSR may run standalone without req">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Spring Boot POM 详解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDEyMTkxNjA5MTA2MDk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Wm1WdVoycHBZVEV3L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>        正如这幅图所展示的那样，在Spring IO Framework体系中，Spring Boot处在Execution layer，来看看官方对这层的解释：</p>
<p>    The Spring IO Execution layer provides domain-specific runtimes (DSRs) for applications built on the IO Foundation modules. A DSR may run standalone without requiring deployment to an external container.</p>
<p>        还是引用官方的话来阐述一下Spring Boot主要是做什么的：</p>
<p>    Spring Boot reduces the effort needed to create production-ready, DevOps-friendly, XML-free Spring applications. It simplifies bootstrapping of Spring projects with minimal code, implements an extensible set of operational features such as automated health<br />
 checking and metrics endpoints, and supports embedded containers enabling the creation of self-contained executables.</p>
<p>        来看看这里的几个关键词：</p>
<p>        Production-ready，DevOps-friendly - 主要集中在Spring Boot Actuator模块，提供线上监控运维相关的特性，比方说health checking，metrics endpoints，或者通过提供诸如maven exec，或者类似one jar那种的self-contained executables。</p>
<p>        XML-free - 预定义了很多Annotation，配置元编程风格。</p>
<p>        Spring Boot给我的感觉更像是Spring社区的DevOps平台，集成并提供了诸如依赖管理，部署自动化，监控运维等特性。</p>
<p>        Ok，到了这篇文章的重点部分。接下来，我们来分析一下Spring Boot是如何组织管理依赖的。来看一下它项目代码的POM结构。</p>
<p>       首先是根目录的Pom，如：</p>
<pre>        &lt;groupId&gt;org.springframework.boot&lt;/groupId&gt;
	&lt;artifactId&gt;spring-boot-build&lt;/artifactId&gt;
	&lt;version&gt;1.2.1.BUILD-SNAPSHOT&lt;/version&gt;
	&lt;packaging&gt;pom&lt;/packaging&gt;
	&lt;name&gt;Spring Boot Build&lt;/name&gt;</pre>
<p>       挺简洁的，除了声明了antrun，surefire和replacer插件外，就定义了包括default，integration，ci在内的三个profile。里面值得关注几个点：</p>
<p>       1. 默认profile里面声明了一系列堪称最小依赖modules，如下：</p>
<pre>&lt;modules&gt;
        &lt;module&gt;spring-boot-dependencies&lt;/module&gt;
        &lt;module&gt;spring-boot-parent&lt;/module&gt;
        &lt;module&gt;spring-boot-versions&lt;/module&gt;
        &lt;module&gt;spring-boot-tools&lt;/module&gt;
        &lt;module&gt;spring-boot&lt;/module&gt;
        &lt;module&gt;spring-boot-autoconfigure&lt;/module&gt;
        &lt;module&gt;spring-boot-actuator&lt;/module&gt;
        &lt;module&gt;spring-boot-docs&lt;/module&gt;
        &lt;module&gt;spring-boot-starters&lt;/module&gt;
        &lt;module&gt;spring-boot-cli&lt;/module&gt;
&lt;/modules&gt;</pre>
<p>     这里面的关系，尤其是父子模块关系，后面会介绍。</p>
<p>     2. 大家可以关注一下com.google.code.maven-replacer-plugin这个插件，主要是做属性文件替换的，和alibaba开源的antx maven插件有些类似。当然如果你热衷于maven的resources的filter机制，相信你会更喜欢这个replacer插件。</p>
<p>    下面，我们来看看上面提到的父子模块关系， spring-boot-dependencies是一个parent pom，如下配置：</p>
<pre>&lt;groupId&gt;org.springframework.boot&lt;/groupId&gt;
  &lt;artifactId&gt;spring-boot-dependencies&lt;/artifactId&gt;
  &lt;version&gt;1.2.1.BUILD-SNAPSHOT&lt;/version&gt;
  &lt;packaging&gt;pom&lt;/packaging&gt;</pre>
<p>     它强制了maven版本，如：
<pre>&lt;prerequisites&gt;
    &lt;maven&gt;3.0.2&lt;/maven&gt;
  &lt;/prerequisites&gt;</pre>
<p>    并用dependencyManagement声明了一堆的依赖，如：</p>
<pre>&lt;properties&gt;
    &lt;!-- Spring Boot --&gt;
    &lt;spring-boot.version&gt;1.2.1.BUILD-SNAPSHOT&lt;/spring-boot.version&gt;
    &lt;!-- Third Party --&gt;
    &lt;activemq.version&gt;5.10.0&lt;/activemq.version&gt;
    &lt;aspectj.version&gt;1.8.4&lt;/aspectj.version&gt;
    &lt;atomikos.version&gt;3.9.3&lt;/atomikos.version&gt;
    &lt;bitronix.version&gt;2.1.4&lt;/bitronix.version&gt;
    &lt;commons-beanutils.version&gt;1.9.2&lt;/commons-beanutils.version&gt;
    &lt;commons-collections.version&gt;3.2.1&lt;/commons-collections.version&gt;
    &lt;commons-dbcp.version&gt;1.4&lt;/commons-dbcp.version&gt;
    &lt;commons-dbcp2.version&gt;2.0.1&lt;/commons-dbcp2.version&gt;
    &lt;commons-digester.version&gt;2.1&lt;/commons-digester.version&gt;
    &lt;commons-pool.version&gt;1.6&lt;/commons-pool.version&gt;
    &lt;commons-pool2.version&gt;2.2&lt;/commons-pool2.version&gt;
    &lt;crashub.version&gt;1.3.0&lt;/crashub.version&gt;
    &lt;dropwizard-metrics.version&gt;3.1.0&lt;/dropwizard-metrics.version&gt;
    &lt;flyway.version&gt;3.0&lt;/flyway.version&gt;
    &lt;freemarker.version&gt;2.3.21&lt;/freemarker.version&gt;
    &lt;gemfire.version&gt;7.0.2&lt;/gemfire.version&gt;
    &lt;glassfish-el.version&gt;3.0.0&lt;/glassfish-el.version&gt;
    &lt;gradle.version&gt;1.6&lt;/gradle.version&gt;
    &lt;groovy.version&gt;2.3.8&lt;/groovy.version&gt;
    &lt;gson.version&gt;2.3&lt;/gson.version&gt;
    &lt;h2.version&gt;1.4.183&lt;/h2.version&gt;
    &lt;hamcrest.version&gt;1.3&lt;/hamcrest.version&gt;
    &lt;hibernate.version&gt;4.3.7.Final&lt;/hibernate.version&gt;
    &lt;hibernate-entitymanager.version&gt;${hibernate.version}&lt;/hibernate-entitymanager.version&gt;
    &lt;hibernate-validator.version&gt;5.1.3.Final&lt;/hibernate-validator.version&gt;
    &lt;hikaricp.version&gt;2.2.5&lt;/hikaricp.version&gt;
    &lt;hornetq.version&gt;2.4.5.Final&lt;/hornetq.version&gt;
    &lt;hsqldb.version&gt;2.3.2&lt;/hsqldb.version&gt;
    &lt;httpasyncclient.version&gt;4.0.2&lt;/httpasyncclient.version&gt;
    &lt;httpclient.version&gt;4.3.6&lt;/httpclient.version&gt;
    &lt;jackson.version&gt;2.4.4&lt;/jackson.version&gt;
    &lt;janino.version&gt;2.6.1&lt;/janino.version&gt;
    &lt;javassist.version&gt;3.18.1-GA&lt;/javassist.version&gt; &lt;!-- Same as Hibernate --&gt;
    &lt;javax-cache.version&gt;1.0.0&lt;/javax-cache.version&gt;
    &lt;javax-mail.version&gt;1.5.2&lt;/javax-mail.version&gt;
    &lt;javax-transaction.version&gt;1.2&lt;/javax-transaction.version&gt;
    &lt;jaxen.version&gt;1.1.6&lt;/jaxen.version&gt;
    &lt;jdom2.version&gt;2.0.5&lt;/jdom2.version&gt;
    &lt;jedis.version&gt;2.5.2&lt;/jedis.version&gt;
    &lt;jersey.version&gt;2.14&lt;/jersey.version&gt;
    &lt;jetty.version&gt;9.2.4.v20141103&lt;/jetty.version&gt;
    &lt;jetty-jsp.version&gt;2.2.0.v201112011158&lt;/jetty-jsp.version&gt;
    &lt;joda-time.version&gt;2.5&lt;/joda-time.version&gt;
    &lt;jolokia.version&gt;1.2.3&lt;/jolokia.version&gt;
    &lt;json-path.version&gt;0.9.1&lt;/json-path.version&gt;
    &lt;jstl.version&gt;1.2&lt;/jstl.version&gt;
    &lt;junit.version&gt;4.12&lt;/junit.version&gt;
    &lt;liquibase.version&gt;3.3.0&lt;/liquibase.version&gt;
    &lt;log4j.version&gt;1.2.17&lt;/log4j.version&gt;
    &lt;log4j2.version&gt;2.1&lt;/log4j2.version&gt;
    &lt;logback.version&gt;1.1.2&lt;/logback.version&gt;
    &lt;mockito.version&gt;1.10.8&lt;/mockito.version&gt;
    &lt;mongodb.version&gt;2.12.4&lt;/mongodb.version&gt;
    &lt;mysql.version&gt;5.1.34&lt;/mysql.version&gt;
    &lt;reactor.version&gt;1.1.5.RELEASE&lt;/reactor.version&gt;
    &lt;reactor-spring.version&gt;1.1.3.RELEASE&lt;/reactor-spring.version&gt;
    &lt;servlet-api.version&gt;3.1.0&lt;/servlet-api.version&gt;
    &lt;simple-json.version&gt;1.1.1&lt;/simple-json.version&gt;
    &lt;slf4j.version&gt;1.7.8&lt;/slf4j.version&gt;
    &lt;snakeyaml.version&gt;1.14&lt;/snakeyaml.version&gt;
    &lt;solr.version&gt;4.7.2&lt;/solr.version&gt;
    &lt;spock.version&gt;0.7-groovy-2.0&lt;/spock.version&gt;
    &lt;spring.version&gt;4.1.3.RELEASE&lt;/spring.version&gt;
    &lt;spring-amqp.version&gt;1.4.1.RELEASE&lt;/spring-amqp.version&gt;
    &lt;spring-cloud-connectors.version&gt;1.1.0.RELEASE&lt;/spring-cloud-connectors.version&gt;
    &lt;spring-batch.version&gt;3.0.2.RELEASE&lt;/spring-batch.version&gt;
    &lt;spring-data-releasetrain.version&gt;Evans-SR1&lt;/spring-data-releasetrain.version&gt;
    &lt;spring-hateoas.version&gt;0.16.0.RELEASE&lt;/spring-hateoas.version&gt;
    &lt;spring-integration.version&gt;4.1.1.RELEASE&lt;/spring-integration.version&gt;
    &lt;spring-loaded.version&gt;1.2.1.RELEASE&lt;/spring-loaded.version&gt;
    &lt;spring-mobile.version&gt;1.1.3.RELEASE&lt;/spring-mobile.version&gt;
    &lt;spring-security.version&gt;3.2.5.RELEASE&lt;/spring-security.version&gt;
    &lt;spring-security-jwt.version&gt;1.0.2.RELEASE&lt;/spring-security-jwt.version&gt;
    &lt;spring-social.version&gt;1.1.0.RELEASE&lt;/spring-social.version&gt;
    &lt;spring-social-facebook.version&gt;1.1.1.RELEASE&lt;/spring-social-facebook.version&gt;
    &lt;spring-social-linkedin.version&gt;1.0.1.RELEASE&lt;/spring-social-linkedin.version&gt;
    &lt;spring-social-twitter.version&gt;1.1.0.RELEASE&lt;/spring-social-twitter.version&gt;
    &lt;spring-ws.version&gt;2.2.0.RELEASE&lt;/spring-ws.version&gt;
    &lt;sun-mail.version&gt;${javax-mail.version}&lt;/sun-mail.version&gt;
    &lt;thymeleaf.version&gt;2.1.3.RELEASE&lt;/thymeleaf.version&gt;
    &lt;thymeleaf-extras-springsecurity3.version&gt;2.1.1.RELEASE&lt;/thymeleaf-extras-springsecurity3.version&gt;
    &lt;thymeleaf-extras-conditionalcomments.version&gt;2.1.1.RELEASE&lt;/thymeleaf-extras-conditionalcomments.version&gt;
    &lt;thymeleaf-layout-dialect.version&gt;1.2.7&lt;/thymeleaf-layout-dialect.version&gt;
    &lt;thymeleaf-extras-data-attribute.version&gt;1.3&lt;/thymeleaf-extras-data-attribute.version&gt;
    &lt;tomcat.version&gt;8.0.15&lt;/tomcat.version&gt;
    &lt;undertow.version&gt;1.1.1.Final&lt;/undertow.version&gt;
    &lt;velocity.version&gt;1.7&lt;/velocity.version&gt;
    &lt;velocity-tools.version&gt;2.0&lt;/velocity-tools.version&gt;
    &lt;wsdl4j.version&gt;1.6.3&lt;/wsdl4j.version&gt;
  &lt;/properties&gt;</pre>
<p>     </p>
<p>     问题来了，spring是如何测试并管理这些非spring生态圈依赖的？奥秘一切尽在下面的示例代码（原理比较简单，请参考文献2）：</p>
<p>   </p>
<pre>&lt;dependencyManagement&gt;
    &lt;dependencies&gt;
        &lt;dependency&gt;
            &lt;groupId&gt;io.spring.platform&lt;/groupId&gt;
            &lt;artifactId&gt;platform-bom&lt;/artifactId&gt;
            &lt;version&gt;2.0.1.RELEASE&lt;/version&gt;
            &lt;type&gt;pom&lt;/type&gt;
            &lt;scope&gt;import&lt;/scope&gt;
        &lt;/dependency&gt;
    &lt;/dependencies&gt;
&lt;/dependencyManagement&gt;</pre>
<p>     除了对Jar的声明依赖，该pom还对maven常见plugin做了声明依赖，用过Maven version插件的同学都会觉得这是一个很好的习惯，对吧。除此之外，里面还有一个plugin git-commit-id-plugin需要额外注意一下，用过buildnumber plugin的同学可能会很好理解该plugin的功能。</p>
<p>     最后来看一下 spring-boot-parent，这是一个二级parent pom，如下图：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDEyMTkxNjA5NDYzNjA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Wm1WdVoycHBZVEV3L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>     重点提一下几个需要注意的点：</p>
<p>    1. 混合使用dependencyManagement和dependencies，这个也是我比较喜欢的。</p>
<p>    2. 详细配置了org.eclipse.m2e插件的lifecycleMappingMetadata，这个也很重要，对那些通过maven project方式将工程导入eclipse的同学无疑是个福音。</p>
<p>    3. maven-enforcer-plugin插件的使用，这个也是我比较喜欢的，目前来看规则还是比较简单的，如：</p>
<pre>&lt;rules&gt;
	&lt;requireJavaVersion&gt;
	&lt;span style="white-space:pre"&gt;	&lt;/span&gt;&lt;version&gt;(1.7,)&lt;/version&gt;
	&lt;/requireJavaVersion&gt;
	&lt;requireProperty&gt;
		&lt;property&gt;main.basedir&lt;/property&gt;
	&lt;/requireProperty&gt;
	&lt;requireProperty&gt;
		&lt;property&gt;project.organization.name&lt;/property&gt;
	&lt;/requireProperty&gt;
	&lt;requireProperty&gt;
		&lt;property&gt;project.name&lt;/property&gt;
	&lt;/requireProperty&gt;
	&lt;requireProperty&gt;
		&lt;property&gt;project.description&lt;/property&gt;
	&lt;/requireProperty&gt;
&lt;/rules&gt;</pre>
<p>       </p>
<p>       更为详细的请参看enforcers官方文档，https://maven.apache.org/enforcer/enforcer-rules/https://maven.apache.org/enforcer/enforcer-rules/</p>
<p>       4. maven-jar-plugin插件的使用，对于那些通过Java package API进行兼容性判断的工具很有用。</p>
<p>       Ok，剩下的几个module都是在该父POM的基础上做了一些个性依赖，没什么好讲的，分析到这里就可以了。希望这篇文章能为那些立志于建立自己顶级POM的团队带来帮助。</p>
<p>参考文献：</p>
<p>1. http://docs.spring.io/spring-boot/docs/current-SNAPSHOT/reference/htmlsingle/#getting-started-introducing-spring-boot</p>
<p>2. https://dzone.com/articles/how-to-use-spring-io-platform-and-spring-boot-toge?utm_source=Top%205&amp;utm_medium=email&amp;utm_campaign=top5%202016-06-10</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-28 05:04:03</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Spring Boot POM 详解的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV93kVp.html" rel="bookmark">Spring Cache抽象详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				缓存简介 缓存,我的理解是:让数据更接近于使用者:工作机制是:先从缓存中读取数据,如果没有再从慢速设备上读取实际数据(数据也会存入缓存):缓存什么:那些经常读取且不经常修改的数据/那些昂贵(CPU/IO)的且对于相同的请求有相同的计算结果的数据.如CPU--L1/L2--内存--磁盘就是一个典型的例子,CPU需要数据时先从L1/L2中读取,如果没有到内存中找,如果还没有会到磁盘上找.还有如用过Maven的朋友都应该知道,我们找依赖的时候,先从本机仓库找,再从本地服务器仓库找,最后到远程仓库服务器			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGJ4akp.html" rel="bookmark">spring mvc DispatcherServlet详解之interceptor和filter的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先我们看一下spring mvc Interceptor的功能及实现: http://wenku.baidu.com/link?url=Mw3GaUhCRMhUFjU8iIDhObQpDcbmmRy_IPeumazg0ppnbmwqFUtLp9kSpuPPpeysf6EnHBLYFeWrbjqMq8BlWKQz_7MSDhGQTVl32fpxCMm SpringMVC 中的Interceptor 拦截器也是相当重要和相当有用的,它的主要作用是拦截用户的请求并进行相应的处理,其他的作用比如通过它			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9Yq0vM.html" rel="bookmark">Spring Security 入门详解&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.Spring Security介绍 Spring Security是基于spring的应用程序提供声明式安全保护的安全性框架,它提供了完整的安全性解决方案,能够在web请求级别和方法调用级别 处理身份证验证和授权．它充分使用了依赖注入和面向切面的技术． Spring security主要是从两个方面解决安全性问题: web请求级别:使用servlet过滤器保护web请求并限制URL级别的访问 方法调用级别:使用Spring AOP保护方法调用,确保具有适当权限的用户采用访问安全保护的方法．			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDeX8Bb.html" rel="bookmark">Spring MVC 笔记 详解配置文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关于web.xml 在Java Web项目中,web.xml文件是用来初始化配置信息:比如欢迎页.servlet.servlet-mapping.filter.listener.启动加载级别等. 这个标准是sun公司设计的,容器通过配置文件web.xml找相应的servlet这样有助于灵活和可维护性. 每个xml文件都有定义它书写规则的Schema文件,这些规则是在 文档类型定义(Document Type Definition,DTD)或模式(schema )中定义的. javaEE的定义we			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkVrB5M.html" rel="bookmark">【Spring】定时任务详解实例-&commat;Scheduled</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处http://blog.csdn.net/qq_26525215 本文源自[大学之旅_谙忆的博客] 最近在做项目时间比较紧张也有比较久没写博客了. 现在项目的Redis缓存需要用到定时任务就学习了一下Spring 的@Scheduled注解.使用起来很简单. 这个例子是建立在之前我的一篇博客的实例上面的. 也就是架好了SSM框架. SSM框架博客的链接 [-&gt;点击访问上篇博客源码-CHX] 首先当然是在Spring的xml配置文件加入task的命名空间 xmlns:task=&quot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4RQEJM.html" rel="bookmark">spring jar 包详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				spring.jar是包含有完整发布的单个jar包,spring.jar中包含除了 spring-mock.jar里所包含的内容外其它所有jar包的内容,因为只有在开发环境下才会用到spring-mock.jar来进行辅助测试, 正式应用系统中是用不得这些类的.除了spring.jar文件,Spring还包括有其它13个独立的jar包,各自包含着对应的Spring组件,用户可以根据自己的需要来选择组合自己的jar包,而不必引入整个spring.jar的所有类文件. (1) spring-core			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAaraZM.html" rel="bookmark">微框架Spring Boot详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spring Boot是由Pivotal团队提供的全新框架,其设计目的是用来简化新 Spring应用的初始搭建以及开发过程.该框架使用了特定的方式来进行配置,从 而使开发人员不再需要定义样板化的配置.通过这种方式,Boot致力于在蓬勃发 展的快速应用开发领域(rapid application development)成为领导者. 多年以来,Spring IO平台饱受非议的一点就是大量的XML配置以及复杂的依赖 管理.在去年的SpringOne 2GX会议上,Pivotal的CTO Adrian			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQBO6wM.html" rel="bookmark">Spring Boot 之 HelloWorld详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.Spring Boot 自述 世界上最好的文档来源自官方的&lt;Spring Boot Reference Guide&gt;,是这样介绍的: Spring Boot makes it easy to create stand-alone, production-grade Spring based Applications that you can &quot;just run&quot;-Most Spring Boot applications need very little Spring			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/YMRkDdp.html" rel="bookmark">详解Spring事务Transaction配置的五种注入方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前段时间对Spring的事务配置做了比较深入的研究,在此之间对Spring的事务配置虽说也配置过,但是一直没有一个清楚的认识.通过这次的学习发觉Spring的事务配置只要把思路理清,还是比较好掌握的. 总结如下: Spring配置文件中关于事务配置总是由三个组成部分,分别是DataSource.TransactionManager和代理机制这三部分,无论哪种配置方式,一般变化的只是代理机制这部分. DataSource.TransactionManager这两部分只是会根据数据访问方式有所变化,			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBVxdb.html" rel="bookmark" class="title">J2ME学习笔记&lpar;九&rpar;</a>
					<div>
						笔记 九 MIDP低级图形处理 MIDP所提供的图形处理方法都在javax.microedition.lcdui里面.主要是如下几个类:Display,Graphic s,Canvas,Font,Im ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ45oz.html" rel="bookmark" class="title">ps美白教程</a>
					<div>
						美白的方法很多,你可以按自己喜欢的方式去处理,只要能保持好皮肤细节的美白方法,都是比较容易获得细腻效果的方法, 美白的方法很多,你可以按自己喜欢的方式去处理,只要能保持好皮肤细节的美白方法,都是比较容 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlROdb.html" rel="bookmark" class="title">自动化测试学习（三） selenium命令</a>
					<div>
						关于,selenium 命令这一部分,为了便于像我一样的菜鸟理解,我采用通过例子讲命令的方式.边学边总结吧!相互学习.呵呵. 菜鸟Selenium 命令通常被称为selenese,有一系列运行测试案例 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6j4jz.html" rel="bookmark" class="title">在Word 2010中使用打开时确认文件格式转换功能</a>
					<div>
						在Word 2010文档中,为了能更好地使用&quot;从任意文件还原文本&quot;功能,用户需要启用&quot;打开时确认文件格 式转换&quot;功能,以在打开并恢复文件时出现文件格式转换对话框 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOw5vvz.html" rel="bookmark" class="title">ASP&period;NET服务器控件封装-【事件】-1&period;2【数据回发】</a>
					<div>
						上节概述: 上节中主要总结了事件处理的机制.控件事件回发.服务端回发事件的捕获及 处理和异步回调等几个方面. 接下来本文将为大家描述&quot;数据回发&quot;的相关细节. 1.IPostBack ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7ernb.html" rel="bookmark" class="title">Socket开发探秘--基于Json格式的数据协议收发</a>
					<div>
						前面发表过两篇随笔:&lt;Socket开发探秘--基类及公共类的定义&gt;和&lt;Socket开发探秘-- 数据封包和拆包&gt;,介绍了Socket方面的开发.本文继续探讨使用Json格式来作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnx5RAb.html" rel="bookmark" class="title">让Dreamweaver支持cshtml等其他文件类型</a>
					<div>
						  (1)添加文件类型: 打开DW,点击工具栏的&quot;编辑&quot;,最下面的&quot;首选参数&quot;,选中&quot;文件类型/编辑器&quot;,在&quot;在代码视图中打开&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWdq0b.html" rel="bookmark" class="title">为Win8系统的开始菜单添加休眠功能</a>
					<div>
						  适用范围: Windows 8 消费者预览版 操作步骤: 1.Win+R 键,弹出运行对话框; 2.输入 gpedit.msc ,点击确定; 3.依次点击&quot;计算机配置&quot;.&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLyx8b.html" rel="bookmark" class="title">Win7服务端口被占得解决方法</a>
					<div>
						Win7服务端口被占得解决方法 Windows命令行窗口下执行,查看80端口的PID号码 C:Userslinuxzgf&gt;netstat -aon |findstr 80 TCP 0.0.0.0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywVw5z.html" rel="bookmark" class="title">阿里开源：思考，演进和发展</a>
					<div>
						关于分享者: 唐容,2011年加入阿里,负责内部开发者服务相关工作,包含内部源码管理,CI/CD等产品研发,2014年开始负责对外云上代码托管和持续交付平台的开发工作.2016年开始负责阿里开源相关的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdPGBM.html" rel="bookmark" class="title">环信EaseUI库怎么集成到项目中？</a>
					<div>
						问题描述 我想把环信最新的EaseUI3.0库集成到项目中,只用到了聊天界面,求详细文档教程 解决方案 可以看下这里  http://docs.easemob.com/doku.p ... guide					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQBeNp.html" rel="bookmark" class="title">安卓 我想实现用代码来选spinner内的第二项</a>
					<div>
						问题描述 安卓 我想实现用代码来选spinner内的第二项 Spinner.performItemClick(Spinner.getChildAt(1),1,Spinner.getItemIdAtPo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA770nz.html" rel="bookmark" class="title">QuickBMS通用解包器使用指南</a>
					<div>
						从本质上来说,QuickBMS只是一个通用解包器引擎,由Luigi Auriemma开发并维护,虽然QuickBMS简单而高效,技术组也经常使用QuickBMS来解包游戏的资源文件,但任何技术都存在一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2P7gop.html" rel="bookmark" class="title">c语言-为什么可以这样写 strcmp&lpar;a&lbrack;i&rsqb;&comma;a&lbrack;i&plus;1&rsqb;&rpar;，这不是说明a&lbrack;i&rsqb;是&ast;类型的吗？有点晕，希望大神指点。</a>
					<div>
						问题描述 为什么可以这样写 strcmp(a[i],a[i+1]),这不是说明a[i]是*类型的吗?有点晕,希望大神指点. a[1]与&amp;a[1]的区别,a[1]可以表示地址吗?a[1]是不是一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40Y9jz.html" rel="bookmark" class="title">IM即时聊天消息怎么按时间来排序</a>
					<div>
						问题描述 最近在做一个IM的即时通讯的项目,现在有遇到一个问题是需要把每次收到的消息(单聊,群聊,**)都排到最前面,类似于手机QQ收到消息的效果 我用了三个hashmap来保存三种不同类型的消息 主 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rd9jp.html" rel="bookmark" class="title">linux报错find&colon; paths must precede expression解决办法</a>
					<div>
						  今天在服务器上执行find ./ -mtime +30 -type f -name *.php的时候,报下面的错误: find: paths must precede expression Usa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEe7EM.html" rel="bookmark" class="title">出钱&comma;学习&period;NET高级软件工程师</a>
					<div>
						问题描述 我在北京蓟门桥附近,希望是家教辅导.我目前初级.NET开发水平.QQ:747011539 解决方案 解决方案二:哈哈,搞笑..高手那有那么多时间浪费给你一个.做管了老师的那有什么高手.解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWrP8z.html" rel="bookmark" class="title">调用android的AlarmManager设定闹钟，在模拟器上面运行成功，小米手机上却不行？</a>
					<div>
						问题描述 调用android的AlarmManager设定闹钟,在模拟器上面运行成功,小米手机上却不行? 下面是代码 new TimePickerDialog(ChooseTiMingTime.thi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7nE5M.html" rel="bookmark" class="title">magento -- 搜索功能的后台管理技巧二</a>
					<div>
						关于Magento的搜索功能,在之前的文章有提到一些(搜索功能的后台管理技巧),这里介绍一下另外一部分,跟Magento最强大的功能之一属性属性有关. 现在国内绝大多数商城,包括京东,凡客甚至是淘宝, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZg9jYb.html" rel="bookmark" class="title">jQuery动态改变多行文本框高度的方法&lowbar;jquery</a>
					<div>
						本文实例讲述了jQuery动态改变多行文本框高度的方法.分享给大家供大家参考,具体如下: &lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Con ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xxx4b.html" rel="bookmark" class="title">网易邮箱极速4&period;0版近日取得最新突破</a>
					<div>
						摘要: 网易邮箱极速4.0版近日取得最新突破,支持语音输入搜索邮件,成为全球首家采用此技术的邮箱运营商. 据网易邮箱极速4.0版项目经理介绍,对于支持 HTML 5最新版本的 Chrome 浏览器以及 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjw1QNM.html" rel="bookmark" class="title">Hadoop遭遇瓶颈的七大危险信号</a>
					<div>
						文章讲的是Hadoop遭遇瓶颈的七大危险信号,大多数企业大数据应用案例尚处于实验和试点阶段,对于少数首次在生产环境部署Hadoop系统的用户来说,最常遇到的就是扩展问题,此类问题往往导致企业因噎废食, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b223Z4b.html" rel="bookmark" class="title">《使命召唤》战役预告片冷战时期的秘密行动</a>
					<div>
						(编译/林洁伊)北京时间10月13日,FPS王牌系列新作&lt;使命召唤:黑色行动&gt;放出了单人模式1分钟完整版的最新高清预告片,该作将在2010年11月9号登陆PC及PS3.Xbox360.Wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwPB5M.html" rel="bookmark" class="title">编程-极坐标到直角坐标转换  matlab</a>
					<div>
						问题描述 极坐标到直角坐标转换 matlab 这是两幅心血管的超声图像,第一幅是我以下面一幅图像的图心做的极坐标变换,现在的问题是如何从极坐标图像编程还原回第二幅图呢,第一幅图大小192*360,第二 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmrxNp.html" rel="bookmark" class="title">PHP中通过HTTP&lowbar;USER&lowbar;AGENT判断是否为手机移动终端的函数代码&lowbar;php技巧</a>
					<div>
						有时候很实用在一些场合,留住备用吧 复制代码 代码如下: function is_mobile_request()       {         $_SERVER['ALL_HTTP'] = iss ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVx8jz.html" rel="bookmark" class="title">c 回溯 背包-C&sol;C&plus;&plus;求纠正逻辑错误，01背包问题</a>
					<div>
						问题描述 C/C++求纠正逻辑错误,01背包问题 原题如下: 公司发了某商店的购物券1000元,限定只能购买店中的m种商品.每种商品的价格分别为m1,m2,-,要求程序列出所有的正好能消费完该购物券的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmV9kBz.html" rel="bookmark" class="title">武汉佰钧成技术有限责任公司&quest;&quest;&quest;这个公司怎么样啊？</a>
					<div>
						问题描述 如题,大家一起来聊聊 解决方案 解决方案二:应该说不怎么样,福利差,报销难,打的限50还要晚上9点半后.解决方案三:引用1楼IFocusYou的回复: 应该说不怎么样,福利差,报销难,打的限 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Q3x6p.html" rel="bookmark" class="title">python 中出现 list  index out of range错误</a>
					<div>
						问题描述 python 中出现 list index out of range错误 目的是实现当falsh中有相同元素时,arrow中相对应的元素相加,同样core中相对应的元素相加.这是我的程序,但 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7n6rM.html" rel="bookmark" class="title">web前端-bracket在线预览出问题了怎么解决</a>
					<div>
						问题描述 bracket在线预览出问题了怎么解决 解决方案 http://blog.csdn.net/zhx1259135417/article/details/40079961					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9N49gp.html" rel="bookmark" class="title">Ubuntu禁用GNOME菜单中的&OpenCurlyDoubleQuote;最近的文档&rdquo;功能</a>
					<div>
						要禁用 GNOME 菜单中的&quot;最近的文档&quot;功能,可以这样做: 代码: $ echo &quot;&quot; &gt; $HOME/.recently-used.xbel$ chm ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
